"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TriggerPop = _interopRequireDefault(require("../_TriggerPop"));
var _AnchorButton = _interopRequireDefault(require("../AnchorButton"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _PopManagement = _interopRequireDefault(require("../_vendors/PopManagement"));
var _excluded = ["children", "className", "contentClassName", "type", "iconVisible", "iconCls", "closeButtonVisible", "closeButtonValue", "onRequestClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Guide = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Guide, _Component);
  var _super = _createSuper(Guide);
  function Guide(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Guide);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var _this$guideInstance, _this$guideInstance$r;
      (_this$guideInstance = _this.guideInstance) === null || _this$guideInstance === void 0 ? void 0 : (_this$guideInstance$r = _this$guideInstance.resetPosition) === null || _this$guideInstance$r === void 0 ? void 0 : _this$guideInstance$r.call(_this$guideInstance);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIconCls", function () {
      switch (_this.props.type) {
        case _MsgType["default"].SUCCESS:
          return 'fas fa-check-circle';
        case _MsgType["default"].WARNING:
          return 'fas fa-exclamation-triangle';
        case _MsgType["default"].ERROR:
          return 'fas fa-times-circle';
        default:
          return 'fas fa-info-circle';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props$onRender, _this$props;
      _PopManagement["default"].push((0, _assertThisInitialized2["default"])(_this));
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      (_this$props$onRender = (_this$props = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call.apply(_this$props$onRender, [_this$props].concat(args));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function () {
      var _this$props$onDestroy, _this$props2;
      _PopManagement["default"].pop((0, _assertThisInitialized2["default"])(_this));
      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }
      (_this$props$onDestroy = (_this$props2 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call.apply(_this$props$onDestroy, [_this$props2].concat(args));
    });
    _this.guide = /*#__PURE__*/(0, _react.createRef)();
    _this.guideInstance = null;
    return _this;
  }
  (0, _createClass2["default"])(Guide, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$guide;
      this.guideInstance = (_this$guide = this.guide) === null || _this$guide === void 0 ? void 0 : _this$guide.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _PopManagement["default"].pop(this);
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _classNames2;
      var _this$props3 = this.props,
        children = _this$props3.children,
        className = _this$props3.className,
        contentClassName = _this$props3.contentClassName,
        type = _this$props3.type,
        iconVisible = _this$props3.iconVisible,
        iconCls = _this$props3.iconCls,
        closeButtonVisible = _this$props3.closeButtonVisible,
        closeButtonValue = _this$props3.closeButtonValue,
        onRequestClose = _this$props3.onRequestClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_TriggerPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.guide,
        className: (0, _classnames["default"])('guide', (0, _defineProperty2["default"])({
          'icon-hidden': !iconVisible
        }, className, className)),
        contentClassName: (0, _classnames["default"])('guide-content', (_classNames2 = {
          'theme-default': type === _MsgType["default"].DEFAULT
        }, (0, _defineProperty2["default"])(_classNames2, "theme-".concat(type), type !== _MsgType["default"].DEFAULT), (0, _defineProperty2["default"])(_classNames2, contentClassName, contentClassName), _classNames2)),
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }), !iconVisible || type === _MsgType["default"].DEFAULT ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])(iconCls ? iconCls : this.getIconCls(), 'guide-icon')
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "guide-message"
      }, children, closeButtonVisible ? /*#__PURE__*/_react["default"].createElement(_AnchorButton["default"], {
        className: "guide-close-Button",
        value: closeButtonValue,
        onClick: onRequestClose
      }) : null));
    }
  }]);
  return Guide;
}(_react.Component);
(0, _defineProperty2["default"])(Guide, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Guide, "Type", _MsgType["default"]);
Guide.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The type of notification.
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  container: _propTypes["default"].element,
  triangle: _propTypes["default"].element,
  /**
   * The guide alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  iconVisible: _propTypes["default"].bool,
  iconCls: _propTypes["default"].string,
  /**
   * If true,guide will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  isEscClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,
  closeButtonVisible: _propTypes["default"].bool,
  closeButtonValue: _propTypes["default"].string,
  /**
   * The function of guide render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of guide rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of guide destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of guide destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when the popover is requested to be closed.
   */
  onRequestClose: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func
};
Guide.defaultProps = {
  parentEl: document.body,
  type: _MsgType["default"].INFO,
  visible: false,
  hasTriangle: true,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  iconVisible: true,
  isBlurClose: true,
  isEscClose: true,
  shouldFollowScroll: false,
  resetPositionWait: 250,
  showModal: false,
  closeButtonVisible: true,
  closeButtonValue: 'Close'
};
var _default = Guide;
exports["default"] = _default;