"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));
var _YearPicker = _interopRequireDefault(require("../_YearPicker"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _moment = _interopRequireDefault(require("moment"));
var _DateUtil = _interopRequireDefault(require("../_vendors/DateUtil"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "dateFormat", "maxValue", "minValue"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MonthRangeField = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MonthRangeField, _Component);
  var _super = _createSuper(MonthRangeField);
  function MonthRangeField(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MonthRangeField);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "datePickerLevelChangeHandle", function (select, selectLevel) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        datePickerLevel: selectLevel
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "monthPickerHoverHandle", function (select, date) {
      var startTime = _this.state.startTime,
        endTime = _this.state.endTime;
      if (startTime && endTime === '') {
        _this.setState({
          hoverTime: date.time,
          left: _objectSpread(_objectSpread({}, _this.state.left), {}, {
            text: (0, _moment["default"])(startTime).isBefore(date.time) ? startTime : date.time
          }),
          right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
            text: (0, _moment["default"])(startTime).isBefore(date.time) ? date.time : startTime
          })
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "monthAndYearChangeHandle", function (select, date) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        year: date.year
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "monthPickerChangeHandle", function (select, date) {
      if (_this.state.endTime) {
        _this.setState((0, _defineProperty2["default"])({
          startTime: date.time,
          endTime: '',
          hoverTime: ''
        }, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
          text: date.time,
          year: date.year,
          month: date.month
        })));
      } else if (_this.state.startTime) {
        var startTime = _this.state.startTime,
          endTime;
        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          endTime = date.time;
        } else {
          endTime = startTime;
          startTime = date.time;
        }
        _this.setState({
          startTime: startTime,
          endTime: endTime,
          historyStartTime: startTime,
          historyEndTime: endTime,
          hoverTime: '',
          value: [(0, _moment["default"])(startTime).format(_this.props.dateFormat), (0, _moment["default"])(endTime).format(_this.props.dateFormat)],
          left: _objectSpread(_objectSpread({}, _this.state.left), {}, {
            text: startTime
          }),
          right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
            text: endTime
          })
        }, function () {
          _this.props.onChange && _this.props.onChange([(0, _moment["default"])(startTime).format(_this.props.dateFormat), (0, _moment["default"])(endTime).format(_this.props.dateFormat)]);
        });
      } else {
        _this.setState((0, _defineProperty2["default"])({
          startTime: date.time,
          endTime: '',
          hoverTime: ''
        }, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
          text: date.time,
          year: date.year,
          month: date.month
        })));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "yearPickerChangeHandle", function (select, year) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        datePickerLevel: 'month',
        year: year
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setValue", function (value, format) {
      if (value && value.length > 1) {
        var leftValue = value[0],
          rightValue = value[1];
        if (!!leftValue) {
          if ((0, _moment["default"])(leftValue, format).isValid() || !!rightValue && (0, _moment["default"])(leftValue, format).isValid()) {
            var left = _objectSpread(_objectSpread({}, _this.state.left), {}, {
                text: leftValue,
                year: (0, _moment["default"])(value[0]).format('YYYY'),
                month: (0, _moment["default"])(value[0]).format('MM')
              }),
              right = _objectSpread(_objectSpread({}, _this.state.right), {}, {
                text: rightValue,
                year: rightValue ? (0, _moment["default"])(value[1]).format('YYYY') : (0, _moment["default"])(value[0]).format('YYYY'),
                month: rightValue ? (0, _moment["default"])(value[1]).format('MM') : (0, _moment["default"])(value[0]).format('MM')
              });
            _this.setState({
              left: _DateUtil["default"].setMonthRange(left, right).start,
              right: _DateUtil["default"].setMonthRange(left, right).end,
              startTime: leftValue,
              endTime: rightValue,
              historyStartTime: leftValue,
              historyEndTime: rightValue
            });
          } else {
            _this.validValue = false;
            console.error('Invalid date');
          }
        } else {
          var _left = _objectSpread(_objectSpread({}, _this.state.left), {}, {
              text: '',
              year: (0, _moment["default"])().format('YYYY'),
              month: (0, _moment["default"])().format('MM')
            }),
            _right = _objectSpread(_objectSpread({}, _this.state.right), {}, {
              text: '',
              year: (0, _moment["default"])().format('YYYY'),
              month: (0, _moment["default"])().format('MM')
            });
          _this.setState({
            left: _DateUtil["default"].setMonthRange(_left, _right).start,
            right: _DateUtil["default"].setMonthRange(_left, _right).end,
            startTime: '',
            endTime: '',
            historyStartTime: '',
            historyEndTime: ''
          });
        }
      } else {
        var _left2 = _objectSpread(_objectSpread({}, _this.state.left), {}, {
            text: '',
            year: (0, _moment["default"])().format('YYYY'),
            month: (0, _moment["default"])().format('MM')
          }),
          _right2 = _objectSpread(_objectSpread({}, _this.state.right), {}, {
            text: '',
            year: (0, _moment["default"])().format('YYYY'),
            month: (0, _moment["default"])().format('MM')
          });
        _this.setState({
          left: _DateUtil["default"].setMonthRange(_left2, _right2).start,
          right: _DateUtil["default"].setMonthRange(_left2, _right2).end,
          startTime: '',
          endTime: '',
          historyStartTime: '',
          historyEndTime: ''
        });
      }
    });
    var initValue = (0, _moment["default"])();
    _this.validValue = true;
    _this.state = {
      value: props.value,
      // Moment object
      left: {
        text: '',
        datePickerLevel: 'month',
        year: initValue.format('YYYY'),
        month: initValue.format('MM')
      },
      right: {
        text: '',
        datePickerLevel: 'month',
        year: initValue.format('MM') === '12' ? +initValue.format('YYYY') + 1 : initValue.format('YYYY'),
        month: initValue.format('MM') === '12' ? 1 : +initValue.format('MM') + 1
      },
      startTime: '',
      endTime: '',
      historyStartTime: '',
      historyEndTime: '',
      hoverTime: ''
    };
    return _this;
  }
  (0, _createClass2["default"])(MonthRangeField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        value = _this$props.value,
        dateFormat = _this$props.dateFormat;
      this.setValue(value, dateFormat);
    }
  }, {
    key: "render",
    value:
    // eslint-disable-next-line complexity
    function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        dateFormat = _this$props2.dateFormat,
        maxValue = _this$props2.maxValue,
        minValue = _this$props2.minValue,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      var _this$state = this.state,
        left = _this$state.left,
        right = _this$state.right,
        startTime = _this$state.startTime,
        endTime = _this$state.endTime,
        hoverTime = _this$state.hoverTime;
      var datePickerLevelChangeHandle = this.datePickerLevelChangeHandle,
        monthPickerHoverHandle = this.monthPickerHoverHandle,
        monthAndYearChangeHandle = this.monthAndYearChangeHandle,
        monthPickerChangeHandle = this.monthPickerChangeHandle,
        yearPickerChangeHandle = this.yearPickerChangeHandle;
      var maxYear = +right.year - 1,
        maxMonth = 11,
        leftMaxValue = right.text && maxValue ? _moment["default"].min((0, _moment["default"])(maxValue), (0, _moment["default"])([maxYear, maxMonth])).format('YYYY-MM') : (0, _moment["default"])([maxYear, 11]).format('YYYY-MM');
      var minYear = +left.year + 1,
        minMonth = 0,
        rightMinValue = left.text && minValue ? _moment["default"].max((0, _moment["default"])(minValue), (0, _moment["default"])([minYear, minMonth])).format('YYYY-MM') : (0, _moment["default"])([minYear, minMonth]).format('YYYY-MM'),
        leftProps = _objectSpread(_objectSpread({}, left), {}, {
          value: left.text,
          maxValue: maxValue && minValue ? (0, _moment["default"])(leftMaxValue).isAfter((0, _moment["default"])(maxValue)) ? maxValue : leftMaxValue : !maxValue && minValue ? _moment["default"].max((0, _moment["default"])(leftMaxValue), (0, _moment["default"])(minValue)).format('YYYY-MM') : maxValue && !minValue ? (0, _moment["default"])(leftMaxValue).isAfter((0, _moment["default"])(maxValue)) ? maxValue : leftMaxValue : leftMaxValue,
          minValue: minValue,
          startTime: startTime,
          endTime: endTime,
          hoverTime: hoverTime,
          dateFormat: dateFormat
        }),
        rightProps = _objectSpread(_objectSpread({}, right), {}, {
          value: right.text,
          minValue: maxValue && minValue ? (0, _moment["default"])(rightMinValue).isAfter((0, _moment["default"])(minValue)) ? rightMinValue : minValue : !maxValue && minValue ? (0, _moment["default"])(rightMinValue).isAfter((0, _moment["default"])(minValue)) ? rightMinValue : minValue : maxValue && !minValue ? _moment["default"].min((0, _moment["default"])(rightMinValue), (0, _moment["default"])(maxValue)).format('YYYY-MM') : rightMinValue,
          maxValue: maxValue,
          startTime: startTime,
          endTime: endTime,
          hoverTime: hoverTime,
          dateFormat: dateFormat
        });
      // console.log(leftProps);
      // console.log(rightProps);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "month-range-picker-content ".concat(className)
      }, left.datePickerLevel === 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], (0, _extends2["default"])({}, restProps, leftProps, {
        isRange: true,
        onChange: function onChange(date) {
          return monthPickerChangeHandle('left', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return datePickerLevelChangeHandle('left', pickerLevel);
        },
        monthAndYearChange: function monthAndYearChange(date) {
          return monthAndYearChangeHandle('left', date);
        },
        hoverHandle: function hoverHandle(date) {
          return monthPickerHoverHandle('left', date);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], (0, _extends2["default"])({}, restProps, leftProps, {
        onChange: function onChange(date) {
          return yearPickerChangeHandle('left', date);
        }
      })), right.datePickerLevel === 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], (0, _extends2["default"])({}, restProps, rightProps, {
        isRange: true,
        onChange: function onChange(date) {
          return monthPickerChangeHandle('right', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return datePickerLevelChangeHandle('right', pickerLevel);
        },
        monthAndYearChange: function monthAndYearChange(date) {
          return monthAndYearChangeHandle('right', date);
        },
        hoverHandle: function hoverHandle(date) {
          return monthPickerHoverHandle('right', date);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], (0, _extends2["default"])({}, restProps, rightProps, {
        onChange: function onChange(date) {
          return yearPickerChangeHandle('right', date);
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        dateFormat = _ComponentUtil["default"].getDerivedState(props, state, 'dateFormat');
      return {
        prevProps: props,
        dateFormat: dateFormat,
        value: value
      };
    }
  }]);
  return MonthRangeField;
}(_react.Component);
(0, _defineProperty2["default"])(MonthRangeField, "Theme", _Theme["default"]);
MonthRangeField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */

  style: _propTypes["default"].object,
  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].array,
  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,
  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,
  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,
  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
MonthRangeField.defaultProps = {
  dateFormat: 'YYYY-MM',
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right'
};
var _default = MonthRangeField;
exports["default"] = _default;