"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _RateCalculation = _interopRequireDefault(require("../_vendors/RateCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Rate = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Rate, _Component);
  var _super = _createSuper(Rate);
  function Rate(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Rate);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "createItems", function (value) {
      var _this$props = _this.props,
        allowHalf = _this$props.allowHalf,
        count = _this$props.count;
      return _RateCalculation["default"].createItems(value, allowHalf, count);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerEvent", function (el, triggerEl) {
      // console.log(el,triggerEl)
      while (el) {
        if (el == triggerEl) {
          return true;
        }
        el = el.parentNode;
      }
      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      var disabled = _this.props.disabled;
      if (disabled) {
        return;
      }
      var mouseEnterFalg = _this.handleTriggerEvent(e.target, _this.wrapperEl);
      var value = _this.props.value;

      // console.log(mouseEnterFalg)
      if (mouseEnterFalg) {
        if (e.target.nodeName === 'I') {
          value = e.target.getAttribute('data-key');
        } else if (e.target.nodeName === 'DIV' && (e.target.className.indexOf('half-star') !== -1 || e.target.className.indexOf('star') !== -1)) {
          value = e.target.getAttribute('data-key');
        }
      } else {
        value = _this.props.value;
      }
      // if(value!==this.props.value){
      var items = _this.createItems(value);
      _this.setState({
        items: items
      });
      // }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (value, e) {
      e.preventDefault();
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        allowClear = _this$props2.allowClear;
      if (disabled) {
        return;
      }
      if (value === _this.state.value && allowClear) {
        value = 0;
      }
      _this.setState({
        value: value
      }, function () {
        _this.props.onChange && _this.props.onChange(value);
      });
    });
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.state = {
      value: 0,
      items: []
    };
    return _this;
  }
  (0, _createClass2["default"])(Rate, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      var value = this.props.value,
        items = this.createItems(value);
      this.setState({
        value: value,
        items: items
      });
      _Event["default"].addEvent(document, 'mousemove', this.handleMouseMove);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.handleMouseMove);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props3 = this.props,
        className = _this$props3.className,
        style = _this$props3.style,
        allowHalf = _this$props3.allowHalf,
        disabled = _this$props3.disabled,
        count = _this$props3.count,
        items = this.state.items;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('rate', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread({
          width: count * 30
        }, style)
      }, items && items.map(function (item, index) {
        return allowHalf ? /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "half-star ".concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "half-star-left",
          "data-key": index + 0.5,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 0.5, e);
          }
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fas fa-star-half ".concat(item == 'full' || item == 'full-zero' ? 'full' : 'zero', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 0.5
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "half-star-right",
          "data-key": index + 1,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 1, e);
          }
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fas fa-star-half ".concat(item == 'zero' || item == 'full-zero' ? 'zero' : 'full', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }))) : /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "star ".concat(disabled ? 'disabled' : ''),
          "data-key": index + 1
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fas fa-star ".concat(item == 'zero' ? 'zero' : 'full', " ").concat(disabled ? 'disabled' : ''),
          "data-key": index + 1,
          onClick: function onClick(e) {
            _this2.handleSelect(index + 1, e);
          }
        }));
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value');
      return {
        prevProps: props,
        value: value,
        items: _RateCalculation["default"].createItems(value, props.allowHalf, props.count)
      };
    }
  }]);
  return Rate;
}(_react.Component);
Rate.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The value of Rate component.
   */
  value: _propTypes["default"].number,
  /**
   * If true,the Rate will have half star.
   */
  allowHalf: _propTypes["default"].bool,
  /**
   * If true,the Rate component will be clear the value when double click.
   */
  allowClear: _propTypes["default"].bool,
  /**
   * If true,the Rate component will be disabled.
   */
  disabled: _propTypes["default"].bool,
  count: _propTypes["default"].number,
  /**
   * Callback function fired when the rate change.
   */
  onChange: _propTypes["default"].func
};
Rate.defaultProps = {
  allowClear: true,
  count: 5,
  defaultValue: 0,
  disabled: false
};
var _default = Rate;
exports["default"] = _default;