"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _TransferList = _interopRequireDefault(require("../_TransferList"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Transfer = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Transfer, _Component);
  var _super = _createSuper(Transfer);
  function Transfer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Transfer);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleLeftSelect", function (data) {
      _this.setState({
        leftSelected: data
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRightSelect", function (data) {
      _this.setState({
        rightSelected: data
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMoveToRight", function () {
      var _this$state = _this.state,
        leftSelected = _this$state.leftSelected,
        leftData = _this$state.leftData,
        rightData = _this$state.rightData;
      var newLeftData = [];
      for (var i = 0; i < leftSelected.length; i++) {
        rightData.push(leftSelected[i]);
      }
      for (var _i = 0; _i < leftData.length; _i++) {
        var flag = false;
        for (var j = 0; j < leftSelected.length; j++) {
          if (leftData[_i].id === leftSelected[j].id) {
            flag = true;
            break;
          }
        }
        if (!flag) {
          newLeftData.push(leftData[_i]);
        }
      }
      _this.setState({
        leftSelected: [],
        leftData: newLeftData,
        rightData: rightData
      }, function () {
        _this.props.onChange && _this.props.onChange();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMoveToLeft", function () {
      var _this$state2 = _this.state,
        rightSelected = _this$state2.rightSelected,
        leftData = _this$state2.leftData,
        rightData = _this$state2.rightData;
      var newRightData = [];
      for (var i = 0; i < rightSelected.length; i++) {
        leftData.push(rightSelected[i]);
      }
      for (var _i2 = 0; _i2 < rightData.length; _i2++) {
        var flag = false;
        for (var j = 0; j < rightSelected.length; j++) {
          if (rightData[_i2].id === rightSelected[j].id) {
            flag = true;
            break;
          }
        }
        if (!flag) {
          newRightData.push(rightData[_i2]);
        }
      }
      _this.setState({
        rightSelected: [],
        leftData: leftData,
        rightData: newRightData
      }, function () {
        _this.props.onChange && _this.props.onChange();
      });
    });
    _this.state = {
      leftData: [],
      rightData: [],
      leftSelected: [],
      rightSelected: []
    };
    return _this;
  }
  (0, _createClass2["default"])(Transfer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        leftData = _this$props.leftData,
        rightData = _this$props.rightData,
        leftSelected = _this$props.leftSelected,
        rightSelected = _this$props.rightSelected;
      this.setState({
        leftData: leftData,
        rightData: rightData,
        leftSelected: leftSelected,
        rightSelected: rightSelected
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        _this$state3 = this.state,
        leftData = _this$state3.leftData,
        rightData = _this$state3.rightData,
        leftSelected = _this$state3.leftSelected,
        rightSelected = _this$state3.rightSelected;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('transfer', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_TransferList["default"], {
        className: "fl",
        data: leftData,
        value: leftSelected,
        onChange: this.handleLeftSelect
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "transfer-operation fl"
      }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        className: "action-button",
        iconCls: "fas fa-angle-right",
        disabled: leftSelected && leftSelected.length < 1,
        onClick: this.handleMoveToRight
      })), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        className: "action-button",
        iconCls: "fas fa-angle-left",
        disabled: rightSelected && rightSelected.length < 1,
        onClick: this.handleMoveToLeft
      }))), /*#__PURE__*/_react["default"].createElement(_TransferList["default"], {
        className: "fl",
        data: rightData,
        value: rightSelected,
        onChange: this.handleRightSelect
      }));
    }
  }]);
  return Transfer;
}(_react.Component);
Transfer.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The data of left select field.
   */
  leftData: _propTypes["default"].array,
  /**
   * The data of left select field.
   */
  rightData: _propTypes["default"].array,
  /**
   * The left-selected data items.
   */
  leftSelected: _propTypes["default"].array,
  /**
   * The left-selected data items.
   */
  rightSelected: _propTypes["default"].array,
  /**
   * Callback function fired when select item changed.
   */
  onChange: _propTypes["default"].func
};
Transfer.defaultProps = {
  leftData: [],
  rightData: [],
  leftSelected: [],
  rightSelected: []
};
var _default = Transfer;
exports["default"] = _default;