"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tr = _interopRequireDefault(require("../_Tr"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CollapsedTableBody = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CollapsedTableBody, _Component);
  var _super = _createSuper(CollapsedTableBody);
  function CollapsedTableBody(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CollapsedTableBody);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemChecked", function (rowData) {
      var _this$props = _this.props,
        selectMode = _this$props.selectMode,
        idField = _this$props.idField,
        value = _this$props.value;
      if (!rowData || !value) {
        return false;
      }
      switch (selectMode) {
        case _SelectMode["default"].MULTI_SELECT:
          return value && value.findIndex(function (item) {
            return item[idField] === rowData[idField];
          }) !== -1;
        case _SelectMode["default"].SINGLE_SELECT:
          return value[idField] === rowData[idField];
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onExpandClick", function (row, rowIndex, colIndex) {
      var _this$props2 = _this.props,
        idField = _this$props2.idField,
        onExpandClick = _this$props2.onExpandClick;
      var expandedList = _this.state.expandedList;
      expandedList[row[idField]] = 'PART';
      _this.setState({
        expandedList: expandedList
      }, function () {
        onExpandClick && onExpandClick(row, rowIndex, colIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onCollapseClick", function (row, rowIndex, colIndex) {
      var _this$props3 = _this.props,
        idField = _this$props3.idField,
        onCollapseClick = _this$props3.onCollapseClick;
      var expandedList = _this.state.expandedList;
      delete expandedList[row[idField]];
      _this.setState({
        expandedList: expandedList
      }, function () {
        onCollapseClick && onCollapseClick(row, rowIndex, colIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onViewAllClick", function (row, rowIndex) {
      var _this$props4 = _this.props,
        idField = _this$props4.idField,
        onViewAllClick = _this$props4.onViewAllClick;
      var expandedList = _this.state.expandedList;
      expandedList[row[idField]] = 'ALL';
      _this.setState({
        expandedList: expandedList
      }, function () {
        onViewAllClick && onViewAllClick(row, rowIndex);
      });
    });
    _this.state = {
      expandedList: {}
    };
    return _this;
  }
  (0, _createClass2["default"])(CollapsedTableBody, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props5 = this.props,
        columns = _this$props5.columns,
        data = _this$props5.data,
        startIndex = _this$props5.startIndex,
        idField = _this$props5.idField,
        disabled = _this$props5.disabled,
        value = _this$props5.value,
        selectMode = _this$props5.selectMode,
        expandedChildrenLimit = _this$props5.expandedChildrenLimit,
        expandedIconCls = _this$props5.expandedIconCls,
        onRowClick = _this$props5.onRowClick,
        onCellClick = _this$props5.onCellClick,
        expandedList = this.state.expandedList;
      return /*#__PURE__*/_react["default"].createElement("tbody", {
        className: "collapsed-table-body"
      }, data && data.map(function (row, rowIndex) {
        return row ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_Tr["default"], {
          key: idField && idField in row ? row[idField] : rowIndex,
          rowIndex: startIndex + rowIndex,
          columns: columns,
          data: row,
          isExpanded: !!expandedList[row[idField]],
          expandedIconCls: expandedIconCls,
          isChecked: _this2.isItemChecked(row),
          disabled: disabled || row.disabled,
          onRowClick: onRowClick,
          onCellClick: onCellClick,
          onExpand: function onExpand(colIndex) {
            idField && idField in row && _this2.onExpandClick(row, rowIndex, colIndex);
          },
          onCollapse: function onCollapse(colIndex) {
            idField && idField in row && _this2.onCollapseClick(row, rowIndex, colIndex);
          }
        }), expandedList[row[idField]] ? !row.children || row.children.length === 0 ? /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "is-expand-loading"
        }, /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], null)))) : row.children.length <= expandedChildrenLimit || expandedList[row[idField]] === 'ALL' ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, row.children.map(function (childRow, childIndex) {
          return childRow ? /*#__PURE__*/_react["default"].createElement(_Tr["default"], {
            className: "expanded-children-row",
            key: idField && idField in childRow ? childRow[idField] : childIndex + 'child',
            rowIndex: startIndex + childIndex,
            columns: columns,
            data: childRow,
            isChecked: _this2.isItemChecked(childRow),
            disabled: disabled || childRow.disabled,
            onRowClick: onRowClick,
            onCellClick: onCellClick
          }) : null;
        })) : /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, row.children.slice(0, expandedChildrenLimit).map(function (childRow, childIndex) {
          return childRow ? /*#__PURE__*/_react["default"].createElement(_Tr["default"], {
            className: "expanded-children-row",
            key: idField && idField in childRow ? childRow[idField] : childIndex + 'child',
            rowIndex: startIndex + childIndex,
            columns: columns,
            data: childRow,
            isChecked: _this2.isItemChecked(childRow),
            disabled: disabled || childRow.disabled,
            onRowClick: onRowClick,
            onCellClick: onCellClick
          }) : null;
        }), /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", null, /*#__PURE__*/_react["default"].createElement("span", {
          className: "view-all",
          onClick: function onClick() {
            _this2.onViewAllClick(row, rowIndex);
          }
        }, "View All(", row.children.length, ")")))) : null) : null;
      }));
    }
  }]);
  return CollapsedTableBody;
}(_react.Component);
(0, _defineProperty2["default"])(CollapsedTableBody, "SelectMode", _SelectMode["default"]);
CollapsedTableBody.propTypes = {
  columns: _propTypes["default"].array,
  data: _propTypes["default"].array,
  startIndex: _propTypes["default"].number,
  expandedChildrenLimit: _propTypes["default"].number,
  idField: _propTypes["default"].string,
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  disabled: _propTypes["default"].bool,
  isItemChecked: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func
};
CollapsedTableBody.defaultProps = {
  data: [],
  columns: [],
  expandedChildrenLimit: 10,
  startIndex: 0,
  idField: 'id',
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  disabled: false
};
var _default = CollapsedTableBody;
exports["default"] = _default;