"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialFieldSeparator = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialFieldSeparator, _Component);
  var _super = _createSuper(MaterialFieldSeparator);
  function MaterialFieldSeparator(props) {
    (0, _classCallCheck2["default"])(this, MaterialFieldSeparator);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    return _super.call.apply(_super, [this, props].concat(restArgs));
  }
  (0, _createClass2["default"])(MaterialFieldSeparator, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        theme = _this$props.theme,
        isHover = _this$props.isHover,
        isFocus = _this$props.isFocus,
        disabled = _this$props.disabled;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('material-field-separator', (0, _defineProperty2["default"])({
          hover: isHover,
          focused: isFocus
        }, "theme-".concat(theme), theme)),
        disabled: disabled
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "material-field-separator-hover"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "material-field-separator-focus"
      }));
    }
  }]);
  return MaterialFieldSeparator;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialFieldSeparator, "Theme", _Theme["default"]);
MaterialFieldSeparator.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  isHover: _propTypes["default"].bool,
  isFocus: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool
};
MaterialFieldSeparator.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isHover: false,
  isFocus: false,
  disabled: false
};
var _default = MaterialFieldSeparator;
exports["default"] = _default;