"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var PaginationPage = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PaginationPage, _Component);
  var _super = _createSuper(PaginationPage);
  function PaginationPage(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, PaginationPage);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getArray", function (number) {
      var array = [];
      for (var i = 1; i <= number; i++) {
        array.push(i);
      }
      return array;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "jump", function (page) {
      var onPageChange = _this.props.onPageChange;
      _this.props.page != page && onPageChange && onPageChange(page);
    });
    return _this;
  }
  (0, _createClass2["default"])(PaginationPage, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        page = _this$props.page,
        totalPage = _this$props.totalPage,
        prevIconCls = _this$props.prevIconCls,
        nextIconCls = _this$props.nextIconCls,
        firstIconCls = _this$props.firstIconCls,
        lastIconCls = _this$props.lastIconCls;
      var pages = null;
      if (totalPage <= 7) {
        var arr = this.getArray(totalPage);
        pages = /*#__PURE__*/_react["default"].createElement("div", {
          className: "pages"
        }, arr && arr.map(function (value, index) {
          return /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            key: index,
            className: "page",
            value: value,
            disabled: index == page,
            onClick: function onClick() {
              return _this2.jump(index);
            }
          });
        }));
      } else {
        if (page < 5) {
          pages = /*#__PURE__*/_react["default"].createElement("div", {
            className: "pages"
          }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "1",
            disabled: page == 0,
            onClick: function onClick() {
              return _this2.jump(0);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "2",
            disabled: page == 1,
            onClick: function onClick() {
              return _this2.jump(1);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "3",
            disabled: page == 2,
            onClick: function onClick() {
              return _this2.jump(2);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "4",
            disabled: page == 3,
            onClick: function onClick() {
              return _this2.jump(3);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "5",
            disabled: page == 4,
            onClick: function onClick() {
              return _this2.jump(4);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "6",
            disabled: page == 5,
            onClick: function onClick() {
              return _this2.jump(5);
            }
          }), /*#__PURE__*/_react["default"].createElement("div", {
            className: "apostrophe"
          }, "..."), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage,
            onClick: function onClick() {
              return _this2.jump(totalPage - 1);
            }
          }));
        } else if (page > totalPage - 5) {
          pages = /*#__PURE__*/_react["default"].createElement("div", {
            className: "pages"
          }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "1",
            onClick: function onClick() {
              return _this2.jump(0);
            }
          }), /*#__PURE__*/_react["default"].createElement("div", {
            className: "apostrophe"
          }, "..."), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage - 5,
            disabled: page == totalPage - 6,
            onClick: function onClick() {
              return _this2.jump(totalPage - 6);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage - 4,
            disabled: page == totalPage - 5,
            onClick: function onClick() {
              return _this2.jump(totalPage - 5);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage - 3,
            disabled: page == totalPage - 4,
            onClick: function onClick() {
              return _this2.jump(totalPage - 4);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage - 2,
            disabled: page == totalPage - 3,
            onClick: function onClick() {
              return _this2.jump(totalPage - 3);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage - 1,
            disabled: page == totalPage - 2,
            onClick: function onClick() {
              return _this2.jump(totalPage - 2);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage,
            disabled: page == totalPage - 1,
            onClick: function onClick() {
              return _this2.jump(totalPage - 1);
            }
          }));
        } else {
          pages = /*#__PURE__*/_react["default"].createElement("div", {
            className: "pages"
          }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: "1",
            onClick: this.jump.bind(this, 0)
          }), /*#__PURE__*/_react["default"].createElement("div", {
            className: "apostrophe"
          }, "..."), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: page - 1,
            onClick: function onClick() {
              return _this2.jump(page - 2);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: page,
            onClick: function onClick() {
              return _this2.jump(page - 1);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: page + 1,
            disabled: true,
            onClick: function onClick() {
              return _this2.jump(page);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: page + 2,
            onClick: function onClick() {
              return _this2.jump(page + 1);
            }
          }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: page + 3,
            onClick: function onClick() {
              return _this2.jump(page + 2);
            }
          }), /*#__PURE__*/_react["default"].createElement("div", {
            className: "apostrophe"
          }, "..."), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
            className: "page",
            value: totalPage,
            onClick: function onClick() {
              return _this2.jump(totalPage - 1);
            }
          }));
        }
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "pagination-page"
      }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "ctrl",
        iconCls: firstIconCls,
        disabled: page == 0,
        onClick: function onClick() {
          return _this2.jump(0);
        }
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "ctrl",
        iconCls: prevIconCls,
        disabled: page == 0,
        onClick: function onClick() {
          return _this2.jump(page - 1 >= 0 ? page - 1 : 0);
        }
      }), pages, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "ctrl",
        iconCls: nextIconCls,
        disabled: page == totalPage - 1 || totalPage == 0,
        onClick: function onClick() {
          return _this2.jump(page + 1 <= totalPage - 1 ? page + 1 : totalPage - 1);
        }
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "ctrl",
        iconCls: lastIconCls,
        disabled: page == totalPage - 1 || totalPage == 0,
        onClick: function onClick() {
          return _this2.jump(totalPage - 1);
        }
      }));
    }
  }]);
  return PaginationPage;
}(_react.Component);
PaginationPage.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  page: _propTypes["default"].number.isRequired,
  totalPage: _propTypes["default"].number.isRequired,
  prevIconCls: _propTypes["default"].string,
  nextIconCls: _propTypes["default"].string,
  firstIconCls: _propTypes["default"].string,
  lastIconCls: _propTypes["default"].string,
  onPageChange: _propTypes["default"].func
};
PaginationPage.defaultProps = {
  page: 0,
  totalPage: 0,
  prevIconCls: 'fas fa-angle-left',
  nextIconCls: 'fas fa-angle-right',
  firstIconCls: 'fas fa-angle-double-left',
  lastIconCls: 'fas fa-angle-double-right'
};
var _default = PaginationPage;
exports["default"] = _default;