"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tf = _interopRequireDefault(require("../_Tf"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _Direction = _interopRequireDefault(require("../_statics/Direction"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _ScrollBar = _interopRequireDefault(require("../_vendors/ScrollBar"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TfootRow = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TfootRow, _Component);
  var _super = _createSuper(TfootRow);
  function TfootRow(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TfootRow);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumnsSpan", function () {
      var _this$props = _this.props,
        columns = _this$props.columns,
        tableData = _this$props.tableData,
        onRequestColumnsSpan = _this$props.onRequestColumnsSpan;
      return onRequestColumnsSpan ? onRequestColumnsSpan(_TableFragment["default"].FOOT, columns, tableData) : _TableCalculation["default"].getColumnsSpan(_TableFragment["default"].FOOT, columns, tableData);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getStyle", function (column, originColumnIndex) {
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        columnKeyField = _this$props2.columnKeyField,
        columnsWidth = _this$props2.columnsWidth,
        defaultColumnWidth = _this$props2.defaultColumnWidth,
        hasVerticalScroll = _this$props2.hasVerticalScroll;
      return _objectSpread(_objectSpread({}, column.footStyle), _TableCalculation["default"].getStickyColumnStyle(column === null || column === void 0 ? void 0 : column.fixed, originColumnIndex, columns, columnKeyField, columnsWidth, defaultColumnWidth, hasVerticalScroll));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props$onFootCli, _this$props4;
      var _this$props3 = _this.props,
        tableData = _this$props3.tableData,
        disabled = _this$props3.disabled;
      !disabled && ((_this$props$onFootCli = (_this$props4 = _this.props).onFootClick) === null || _this$props$onFootCli === void 0 ? void 0 : _this$props$onFootCli.call(_this$props4, tableData, e));
    });
    return _this;
  }
  (0, _createClass2["default"])(TfootRow, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !nextProps.resizingColumn;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props5 = this.props,
        data = _this$props5.data,
        tableData = _this$props5.tableData,
        footData = _this$props5.footData,
        disabled = _this$props5.disabled,
        ignoreColumnSpan = _this$props5.ignoreColumnSpan,
        rowIndex = _this$props5.rowIndex,
        scrollEl = _this$props5.scrollEl,
        hasVerticalScroll = _this$props5.hasVerticalScroll,
        hasFixedRightColumn = _this$props5.hasFixedRightColumn,
        onCellClick = _this$props5.onCellClick;
      var columnsSpan = this.getColumnsSpan();
      var verticalScrollBarSize = _ScrollBar["default"].getSize(_Direction["default"].VERTICAL);
      return /*#__PURE__*/_react["default"].createElement("tr", null, columnsSpan === null || columnsSpan === void 0 ? void 0 : columnsSpan.map(function (_ref, colIndex) {
        var _columnsSpan, _columnsSpan$column, _columnsSpan2, _columnsSpan2$column;
        var column = _ref.column,
          span = _ref.span,
          originColumnIndex = _ref.originColumnIndex;
        return /*#__PURE__*/_react["default"].createElement(_Tf["default"], {
          key: colIndex,
          className: (0, _classnames["default"])(column.footClassName, {
            'fixed-left': column.fixed === _HorizontalAlign["default"].LEFT,
            'last-fixed-left': column.fixed === _HorizontalAlign["default"].LEFT && (columnsSpan === null || columnsSpan === void 0 ? void 0 : (_columnsSpan = columnsSpan[colIndex + 1]) === null || _columnsSpan === void 0 ? void 0 : (_columnsSpan$column = _columnsSpan.column) === null || _columnsSpan$column === void 0 ? void 0 : _columnsSpan$column.fixed) !== _HorizontalAlign["default"].LEFT,
            'fixed-right': column.fixed === _HorizontalAlign["default"].RIGHT,
            'first-fixed-right': column.fixed === _HorizontalAlign["default"].RIGHT && (columnsSpan === null || columnsSpan === void 0 ? void 0 : (_columnsSpan2 = columnsSpan[colIndex - 1]) === null || _columnsSpan2 === void 0 ? void 0 : (_columnsSpan2$column = _columnsSpan2.column) === null || _columnsSpan2$column === void 0 ? void 0 : _columnsSpan2$column.fixed) !== _HorizontalAlign["default"].RIGHT
          }),
          style: _this2.getStyle(column, originColumnIndex),
          rowIndex: rowIndex,
          colIndex: colIndex,
          rowData: data,
          tableData: tableData,
          footData: footData,
          title: column.footTitle,
          renderer: column.footRenderer,
          bodyRenderer: column.bodyRenderer,
          align: column.footAlign || column.align,
          span: ignoreColumnSpan ? null : span,
          noWrap: _TableCalculation["default"].handleNoWrap(column.footNoWrap, column.noWrap, {
            data: tableData,
            rowIndex: 0,
            colIndex: colIndex,
            tableData: tableData
          }),
          disabled: disabled,
          scrollEl: scrollEl,
          onCellClick: onCellClick
        });
      }), hasVerticalScroll && columnsSpan && verticalScrollBarSize > 0 ? /*#__PURE__*/_react["default"].createElement("td", {
        className: (0, _classnames["default"])('scroll-bar-tf', {
          'fixed-right': hasFixedRightColumn
        }),
        style: _objectSpread({
          width: verticalScrollBarSize
        }, hasFixedRightColumn ? {
          position: 'sticky',
          right: 0
        } : null)
      }) : null);
    }
  }]);
  return TfootRow;
}(_react.Component);
(0, _defineProperty2["default"])(TfootRow, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(TfootRow, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TfootRow, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(TfootRow, "SortingType", _SortingType["default"]);
TfootRow.propTypes = {
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  data: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  ignoreColumnSpan: _propTypes["default"].bool,
  rowIndex: _propTypes["default"].number,
  /**
   * scroll
   */
  scrollEl: _propTypes["default"].object,
  hasVerticalScroll: _propTypes["default"].bool,
  /**
   * fixed
   */
  hasFixedRightColumn: _propTypes["default"].bool,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  onFootClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onRequestColumnsSpan: _propTypes["default"].func
};
TfootRow.defaultProps = {
  columnKeyField: 'key',
  disabled: false,
  ignoreColumnSpan: false,
  /**
   * scroll
   */
  hasVerticalScroll: false,
  /**
   * fixed
   */
  hasFixedRightColumn: false,
  /**
   * column resizable
   */
  defaultColumnWidth: 100
};
var _default = TfootRow;
exports["default"] = _default;