"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
/**
 * @file DateCalculation vendor
 */

function weekday(selectYear, selectMonth) {
  var num = new Date(selectYear + '/' + selectMonth + '/01').getDay();
  return num === 0 ? 7 : num;
}
function rangeData(range, minValue, maxValue, isRequired) {
  var arr = [];
  for (var i = 0; i < range; i++) {
    if (i < 10) {
      i = '0' + i;
    }
    var obj = void 0;
    if (isRequired) {
      +i > +maxValue || +i < +minValue ? obj = {
        text: i,
        value: false
      } : obj = {
        text: i,
        value: true
      };
    } else {
      obj = {
        text: i,
        value: true
      };
    }
    arr.push(obj);
  }
  return arr;
}
var _default = {
  weekday: weekday,
  rangeData: rangeData
};
exports["default"] = _default;