"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ArrowStepItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ArrowStepItem, _Component);
  var _super = _createSuper(ArrowStepItem);
  function ArrowStepItem(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ArrowStepItem);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
        isActivatedStep = _this$props.isActivatedStep,
        isFinishedStep = _this$props.isFinishedStep,
        index = _this$props.index,
        onClick = _this$props.onClick;
      !isActivatedStep && isFinishedStep && (onClick === null || onClick === void 0 ? void 0 : onClick(index, e));
    });
    return _this;
  }
  (0, _createClass2["default"])(ArrowStepItem, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        isActivatedStep = _this$props2.isActivatedStep,
        isFinishedStep = _this$props2.isFinishedStep,
        isFirstStepLeftTriangleVisible = _this$props2.isFirstStepLeftTriangleVisible,
        isLastStepRightTriangleVisible = _this$props2.isLastStepRightTriangleVisible,
        index = _this$props2.index,
        value = _this$props2.value,
        isFirst = _this$props2.isFirst,
        isLast = _this$props2.isLast;
      var triangleClassName = isActivatedStep ? 'activated' : isFinishedStep ? 'finished' : '';
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('arrow-step-item', isActivatedStep ? 'activated' : isFinishedStep ? 'finished' : '', (0, _defineProperty2["default"])({
          first: isFirst,
          last: isLast,
          'has-first-step-left-triangle': isFirst && isFirstStepLeftTriangleVisible,
          'has-last-step-right-triangle': isLast && isLastStepRightTriangleVisible
        }, className, className)),
        style: style,
        onClick: this.handleClick
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "arrow-step-item-content"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "number"
      }, index + 1), /*#__PURE__*/_react["default"].createElement("div", {
        className: "title"
      }, value.title)), isFirst && !isFirstStepLeftTriangleVisible ? null : /*#__PURE__*/_react["default"].createElement("div", {
        className: "triangle-wrapper triangle-wrapper-left"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-top', triangleClassName)
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-bottom', triangleClassName)
      })), isLast && !isLastStepRightTriangleVisible ? null : /*#__PURE__*/_react["default"].createElement("div", {
        className: "triangle-wrapper triangle-wrapper-right"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('triangle-middle', triangleClassName)
      })));
    }
  }]);
  return ArrowStepItem;
}(_react.Component);
ArrowStepItem.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  index: _propTypes["default"].number,
  isActivatedStep: _propTypes["default"].bool,
  isFinishedStep: _propTypes["default"].bool,
  value: _propTypes["default"].object,
  isFirst: _propTypes["default"].bool,
  isLast: _propTypes["default"].bool,
  isFirstStepLeftTriangleVisible: _propTypes["default"].bool,
  isLastStepRightTriangleVisible: _propTypes["default"].bool,
  onClick: _propTypes["default"].func
};
ArrowStepItem.defaultProps = {
  index: 0,
  isActivatedStep: false,
  isFinishedStep: false,
  isFirst: true,
  isLast: true,
  isFirstStepLeftTriangleVisible: false,
  isLastStepRightTriangleVisible: false
};
var _default = ArrowStepItem;
exports["default"] = _default;