"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _DropdownSelect = _interopRequireDefault(require("../DropdownSelect"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var PaginationSize = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(PaginationSize, _Component);
  var _super = _createSuper(PaginationSize);
  function PaginationSize(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, PaginationSize);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePageSizeChange", function (newPageSize) {
      var _this$props = _this.props,
        pageSize = _this$props.pageSize,
        onPageSizeChange = _this$props.onPageSizeChange;
      pageSize != newPageSize && onPageSizeChange && onPageSizeChange(newPageSize);
    });
    return _this;
  }
  (0, _createClass2["default"])(PaginationSize, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        triggerClassName = _this$props2.triggerClassName,
        popupClassName = _this$props2.popupClassName,
        style = _this$props2.style,
        pageSize = _this$props2.pageSize,
        pageSizes = _this$props2.pageSizes,
        valueField = _this$props2.valueField,
        displayField = _this$props2.displayField,
        rightIconCls = _this$props2.rightIconCls,
        parentEl = _this$props2.parentEl,
        temp = pageSizes.find(function (item) {
          return item && item.value === pageSize;
        }),
        value = temp ? temp : pageSize;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('pagination-size', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("label", null, "Show Rows:"), /*#__PURE__*/_react["default"].createElement(_DropdownSelect["default"], {
        className: (0, _classnames["default"])('pagination-size-select', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName)),
        popupClassName: popupClassName,
        value: value,
        data: pageSizes,
        autoClose: true,
        valueField: valueField,
        displayField: displayField,
        parentEl: parentEl,
        rightIconCls: rightIconCls,
        onChange: this.handlePageSizeChange
      }));
    }
  }]);
  return PaginationSize;
}(_react.Component);
PaginationSize.propTypes = {
  className: _propTypes["default"].string,
  triggerClassName: _propTypes["default"].string,
  popupClassName: _propTypes["default"].string,
  style: _propTypes["default"].object,
  pageSize: _propTypes["default"].number,
  pageSizes: _propTypes["default"].array,
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  onPageSizeChange: _propTypes["default"].func
};
PaginationSize.defaultProps = {
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  valueField: 'value',
  displayField: 'text',
  rightIconCls: 'fas fa-angle-down'
};
var _default = PaginationSize;
exports["default"] = _default;