"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var QuarterPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(QuarterPicker, _Component);
  var _super = _createSuper(QuarterPicker);
  function QuarterPicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, QuarterPicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousLevel", function () {
      var _this$props$previousC, _this$props;
      (_this$props$previousC = (_this$props = _this.props).previousClick) === null || _this$props$previousC === void 0 ? void 0 : _this$props$previousC.call(_this$props, 'year');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (selectQuarter) {
      var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        dateFormat = _this$props2.dateFormat,
        selectYear = _this.state.selectYear,
        timer = (0, _moment["default"])([Number(selectYear)]).quarter(+selectQuarter).format(dateFormat);
      _this.setState({
        currentYear: selectYear,
        currentQuarter: selectQuarter
      }, function () {
        onChange && onChange({
          time: timer,
          year: selectYear,
          quarter: selectQuarter
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var quarterAndYearChange = _this.props.quarterAndYearChange,
        _this$state = _this.state,
        currentYear = _this$state.currentYear,
        currentQuarter = _this$state.currentQuarter,
        selectYear = _this$state.selectYear;
      _this.setState({
        selectYear: +selectYear - 1,
        selectQuarter: +currentYear === +selectYear - 1 ? currentQuarter : undefined
      }, function () {
        quarterAndYearChange === null || quarterAndYearChange === void 0 ? void 0 : quarterAndYearChange({
          year: +selectYear - 1,
          quarter: +currentYear === +selectYear - 1 ? currentQuarter : undefined
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var quarterAndYearChange = _this.props.quarterAndYearChange,
        _this$state2 = _this.state,
        currentYear = _this$state2.currentYear,
        currentQuarter = _this$state2.currentQuarter,
        selectYear = _this$state2.selectYear;
      _this.setState({
        selectYear: +selectYear + 1,
        selectQuarter: +currentYear === +selectYear + 1 ? currentQuarter : undefined
      }, function () {
        quarterAndYearChange === null || quarterAndYearChange === void 0 ? void 0 : quarterAndYearChange({
          year: +selectYear + 1,
          quarter: +currentYear === +selectYear + 1 ? currentQuarter : undefined
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hoverDateHandle", function (selectQuarter) {
      var _this$props3 = _this.props,
        hoverHandle = _this$props3.hoverHandle,
        dateFormat = _this$props3.dateFormat,
        selectYear = _this.state.selectYear,
        quarter = +selectQuarter,
        timer = (0, _moment["default"])([Number(selectYear)]).quarter(+selectQuarter).format(dateFormat);
      hoverHandle && hoverHandle({
        time: timer,
        year: selectYear,
        quarter: quarter
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "rangeDateCurrentQuartersRender", function () {
      var _this$props4 = _this.props,
        startTime = _this$props4.startTime,
        endTime = _this$props4.endTime,
        hoverTime = _this$props4.hoverTime,
        maxValue = _this$props4.maxValue,
        minValue = _this$props4.minValue,
        selectYear = _this.state.selectYear,
        _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
        selectDate = _assertThisInitialize.selectDate,
        hoverDateHandle = _assertThisInitialize.hoverDateHandle;
      var currentQuarters = [],
        quartersList = [],
        quarterEn = ['Q1', 'Q2', 'Q3', 'Q4'],
        start = (0, _moment["default"])(endTime).isBefore(startTime) ? endTime : startTime,
        end = (0, _moment["default"])(endTime).isBefore(startTime) ? startTime : endTime,
        hover = (0, _moment["default"])(hoverTime).isBefore(startTime) ? startTime : hoverTime;
      start = (0, _moment["default"])(hoverTime).isBefore(startTime) ? hoverTime : startTime;
      var _loop = function _loop(i) {
        var item = (0, _moment["default"])([Number(selectYear)]).quarter(i + 1).format('YYYY-Q'),
          liClassName = (0, _classnames["default"])({
            'hover': start && hover && (0, _moment["default"])(item).isBetween(start, hover, null, '[]'),
            'current-years': !(maxValue && (0, _moment["default"])(maxValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +maxValue.split('-')[1] < i + 1) || minValue && (0, _moment["default"])(minValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +minValue.split('-')[1] > i + 1,
            'item-gray': maxValue && (0, _moment["default"])(item).isAfter(maxValue) || minValue && (0, _moment["default"])(item).isBefore(minValue),
            'active': start && !end && start === item || start && end && (0, _moment["default"])(item).isBetween(start, end, null, '[]')
          });
        currentQuarters.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            return liClassName.indexOf('item-gray') === -1 && selectDate(i + 1);
          },
          onMouseOver: function onMouseOver() {
            return liClassName.indexOf('item-gray') === -1 && hoverDateHandle(i + 1);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, quarterEn[i], liClassName.indexOf('item-gray') === -1 ? /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null) : null)));
      };
      for (var i = 0; i < quarterEn.length; i++) {
        _loop(i);
      }
      if (currentQuarters.length > 0) {
        for (var _i = 0; _i < _this.defaultTable.row_number; _i++) {
          var rowlist = [],
            startIndex = _i * _this.defaultTable.col_number,
            endIndex = (_i + 1) * _this.defaultTable.col_number;
          for (var j = startIndex; j < endIndex; j++) {
            rowlist.push(currentQuarters[j]);
          }
          quartersList.push(rowlist);
        }
      }
      return quartersList;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "singleDateCurrentQuartersRender", function () {
      var _this$props5 = _this.props,
        maxValue = _this$props5.maxValue,
        minValue = _this$props5.minValue,
        selectMode = _this$props5.selectMode,
        value = _this$props5.value,
        _this$state3 = _this.state,
        selectYear = _this$state3.selectYear,
        selectQuarter = _this$state3.selectQuarter,
        currentYear = _this$state3.currentYear,
        _assertThisInitialize2 = (0, _assertThisInitialized2["default"])(_this),
        selectDate = _assertThisInitialize2.selectDate,
        quarterEn = ['Q1', 'Q2', 'Q3', 'Q4'];
      var currentQuarters = [],
        quartersList = [];
      var _loop2 = function _loop2(i) {
        var liClassName = (0, _classnames["default"])({
          'active': selectMode === _SelectMode["default"].SINGLE_SELECT ? Number(currentYear) === Number(selectYear) && Number(selectQuarter) === i + 1 : value.find(function (item) {
            return (0, _moment["default"])(item).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && Number(item === null || item === void 0 ? void 0 : item.split('-')[1]) === i + 1;
          }),
          'item-gray': maxValue && (0, _moment["default"])(maxValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +(maxValue === null || maxValue === void 0 ? void 0 : maxValue.split('-')[1]) < i + 1 || minValue && (0, _moment["default"])(minValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +(minValue === null || minValue === void 0 ? void 0 : minValue.split('-')[1]) > i + 1,
          'current-years': !(maxValue && (0, _moment["default"])(maxValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +(maxValue === null || maxValue === void 0 ? void 0 : maxValue.split('-')[1]) < i + 1) || minValue && (0, _moment["default"])(minValue).format('YYYY') === (selectYear === null || selectYear === void 0 ? void 0 : selectYear.toString()) && +(minValue === null || minValue === void 0 ? void 0 : minValue.split('-')[1]) > i + 1
        });
        currentQuarters.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            liClassName.indexOf('item-gray') === -1 && selectDate(i + 1);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, quarterEn[i], liClassName.indexOf('item-gray') === -1 ? /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null) : null)));
      };
      for (var i = 0; i < quarterEn.length; i++) {
        _loop2(i);
      }
      if (currentQuarters.length > 0) {
        for (var _i2 = 0; _i2 < _this.defaultTable.row_number; _i2++) {
          var rowlist = [],
            startIndex = _i2 * _this.defaultTable.col_number,
            endIndex = (_i2 + 1) * _this.defaultTable.col_number;
          for (var j = startIndex; j < endIndex; j++) {
            rowlist.push(currentQuarters[j]);
          }
          quartersList.push(rowlist);
        }
      }
      return quartersList;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "quartersRender", function () {
      var isRange = _this.props.isRange;
      return isRange ? _this.rangeDateCurrentQuartersRender() : _this.singleDateCurrentQuartersRender();
    });
    _this.defaultTable = {
      // eslint-disable-next-line camelcase
      row_number: 1,
      // eslint-disable-next-line camelcase
      col_number: 4
    };
    _this.state = {
      selectYear: props.year,
      selectQuarter: props.quarter,
      currentYear: (0, _moment["default"])(props.value).format('YYYY'),
      currentQuarter: props.value.split('-')[1]
    };
    return _this;
  }
  (0, _createClass2["default"])(QuarterPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props6 = this.props,
        value = _this$props6.value,
        year = _this$props6.year,
        quarter = _this$props6.quarter;
      if (value && year && quarter) {
        this.setState({
          selectYear: year,
          selectQuarter: quarter,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentQuarter: value.split('-')[1]
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      // eslint-disable-next-line react/prop-types
      var _this$props7 = this.props,
        campareSelfLeft = _this$props7.campareSelfLeft,
        campareSelfRight = _this$props7.campareSelfRight,
        maxValue = _this$props7.maxValue,
        minValue = _this$props7.minValue,
        previousYearIconCls = _this$props7.previousYearIconCls,
        nextYearIconCls = _this$props7.nextYearIconCls,
        selectYear = this.state.selectYear,
        previousYear = this.previousYear,
        nextYear = this.nextYear,
        previousLevel = this.previousLevel,
        quartersRenderArray = this.quartersRender();
      var leftNextYear = false,
        // maxValue && (
        //     +maxValue.split('-')[1] === 1 ?
        //         +moment(maxValue).format('YYYY') - 1 <= +selectYear
        //         :
        //         +moment(maxValue).format('YYYY') <= +selectYear
        // ),
        rightPreYear = false;
      // minValue && (
      //     +minValue.split('-')[1] === 4 ?
      //         +moment(minValue).format('YYYY') + 1 >= +selectYear
      //         :
      //         +moment(minValue).format('YYYY') >= +selectYear
      // );

      if (campareSelfLeft) {
        if (minValue) {
          rightPreYear = +(0, _moment["default"])(minValue).format('YYYY') >= +selectYear;
        } else {
          rightPreYear = false;
        }
      } else {
        rightPreYear = +minValue.split('-')[1] === 4 ? +(0, _moment["default"])(minValue).format('YYYY') + 1 >= +selectYear : +(0, _moment["default"])(minValue).format('YYYY') >= +selectYear;
      }
      if (campareSelfRight) {
        if (maxValue) {
          leftNextYear = +(0, _moment["default"])(maxValue).format('YYYY') <= +selectYear;
        } else {
          leftNextYear = false;
        }
      } else {
        leftNextYear = +maxValue.split('-')[1] === 1 ? +(0, _moment["default"])(maxValue).format('YYYY') - 1 <= +selectYear : +(0, _moment["default"])(maxValue).format('YYYY') <= +selectYear;
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: 'calendar'
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-header"
      }, rightPreYear ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('previous-year', (0, _defineProperty2["default"])({}, previousYearIconCls, previousYearIconCls)),
        onClick: previousYear
      }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)), /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames["default"])('date-text', {
          disabled: rightPreYear && leftNextYear
        }),
        onClick: function onClick() {
          (!rightPreYear || !leftNextYear) && (previousLevel === null || previousLevel === void 0 ? void 0 : previousLevel());
        }
      }, selectYear), leftNextYear ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('next-year', (0, _defineProperty2["default"])({}, nextYearIconCls, nextYearIconCls)),
        onClick: nextYear
      }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-body  calendar-quarter-body"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "c-body-content"
      }, quartersRenderArray && quartersRenderArray.map(function (item, key) {
        return /*#__PURE__*/_react["default"].createElement("ul", {
          key: 'ul' + key,
          className: "content-row quarter"
        }, item);
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        selectMode = _ComponentUtil["default"].getDerivedState(props, state, 'selectMode'),
        selectYear = _ComponentUtil["default"].getDerivedState(props, state, 'year', 'selectYear'),
        selectQuarter = _ComponentUtil["default"].getDerivedState(props, state, 'quarter', 'selectQuarter');
      return {
        prevProps: props,
        value: value,
        selectMode: selectMode,
        selectYear: selectYear,
        selectQuarter: selectQuarter,
        currentYear: (0, _moment["default"])(props.value).format('YYYY'),
        currentQuarter: props.value.split('-')[1]
      };
    }
  }]);
  return QuarterPicker;
}(_react.Component);
QuarterPicker.propTypes = {
  className: _propTypes["default"].string,
  value: _propTypes["default"].any,
  isRange: _propTypes["default"].bool,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  startTime: _propTypes["default"].string,
  endTime: _propTypes["default"].any,
  hoverTime: _propTypes["default"].any,
  otherSelectedDate: _propTypes["default"].array,
  dateFormat: _propTypes["default"].string,
  /**
   * The mode of monthField.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  quarter: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  hoverHandle: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  quarterAndYearChange: _propTypes["default"].func,
  previousClick: _propTypes["default"].func
};
QuarterPicker.defaultProps = {
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  isRange: false,
  otherSelectedDate: []
};
var _default = QuarterPicker;
exports["default"] = _default;