"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _FlatButton = _interopRequireDefault(require("../FlatButton"));
var _classnames = _interopRequireDefault(require("classnames"));
var _excluded = ["className", "style", "index", "isTabFullWidth", "activated", "draggable", "data", "activatedIndex"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TabButton = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TabButton, _Component);
  var _super = _createSuper(TabButton);
  function TabButton(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TabButton);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      var _this$props$onMouseDo, _this$props2;
      var _this$props = _this.props,
        data = _this$props.data,
        index = _this$props.index;
      (_this$props$onMouseDo = (_this$props2 = _this.props).onMouseDown) === null || _this$props$onMouseDo === void 0 ? void 0 : _this$props$onMouseDo.call(_this$props2, data, index, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseUp", function (e) {
      var _this$props$onMouseUp, _this$props4;
      var _this$props3 = _this.props,
        data = _this$props3.data,
        index = _this$props3.index;
      (_this$props$onMouseUp = (_this$props4 = _this.props).onMouseUp) === null || _this$props$onMouseUp === void 0 ? void 0 : _this$props$onMouseUp.call(_this$props4, data, index, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props$onClick, _this$props6;
      var _this$props5 = _this.props,
        data = _this$props5.data,
        index = _this$props5.index;
      (_this$props$onClick = (_this$props6 = _this.props).onClick) === null || _this$props$onClick === void 0 ? void 0 : _this$props$onClick.call(_this$props6, data, index, e);
    });
    return _this;
  }
  (0, _createClass2["default"])(TabButton, [{
    key: "render",
    value: function render() {
      var _this$props7 = this.props,
        className = _this$props7.className,
        style = _this$props7.style,
        index = _this$props7.index,
        isTabFullWidth = _this$props7.isTabFullWidth,
        activated = _this$props7.activated,
        draggable = _this$props7.draggable,
        data = _this$props7.data,
        activatedIndex = _this$props7.activatedIndex,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props7, _excluded);
      var trigger = /*#__PURE__*/_react["default"].createElement(_FlatButton["default"], (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('tab-button', (0, _defineProperty2["default"])({
          activated: activated
        }, className, className)),
        style: style,
        container: /*#__PURE__*/_react["default"].createElement("div", null),
        disableTouchRipple: true,
        onMouseDown: this.handleMouseDown,
        onMouseUp: this.handleMouseUp,
        onClick: this.handleClick
      }));
      return isTabFullWidth ? trigger : /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Draggable, {
        key: index,
        draggableId: '' + index,
        index: index,
        isDragDisabled: !draggable
      }, function (dragProvided) {
        return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          ref: dragProvided.innerRef,
          className: "tab-button-wrapper",
          style: dragProvided.draggableStyle
        }, dragProvided.draggableProps, dragProvided.dragHandleProps), trigger);
      });
    }
  }]);
  return TabButton;
}(_react.Component);
TabButton.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Children passed into the TabsItem.
   */
  data: _propTypes["default"].shape({
    /**
     * The text value of the tab.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the tab will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the tab will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon.It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * The position of the icon.
     */
    iconPosition: _propTypes["default"].string,
    /**
     * The render content in tab.
     */
    renderer: _propTypes["default"].any,
    /**
     * Callback function fired when click onActive tab.
     */
    onActive: _propTypes["default"].func
  }).isRequired,
  /**
   * Activated tab index.
   */
  activatedIndex: _propTypes["default"].number,
  index: _propTypes["default"].number,
  activated: _propTypes["default"].bool,
  /**
   * If true,the data is FullWidth.
   */
  isTabFullWidth: _propTypes["default"].bool,
  draggable: _propTypes["default"].bool,
  idField: _propTypes["default"].string,
  onMouseDown: _propTypes["default"].func,
  onMouseUp: _propTypes["default"].func,
  onClick: _propTypes["default"].func
};
TabButton.defaultProps = {
  activatedIndex: 0,
  index: 0,
  activated: false,
  isTabFullWidth: true,
  draggable: false
};
var _default = TabButton;
exports["default"] = _default;