"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ThSortingIcon = _interopRequireDefault(require("../_ThSortingIcon"));
var _ResizableTh = _interopRequireDefault(require("../_ResizableTh"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Th = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Th, _Component);
  var _super = _createSuper(Th);
  function Th(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Th);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function () {
      var _this$props = _this.props,
        colIndex = _this$props.colIndex,
        data = _this$props.data,
        scrollEl = _this$props.scrollEl,
        renderer = _this$props.renderer;
      switch ((0, _typeof2["default"])(renderer)) {
        case 'function':
          return renderer === null || renderer === void 0 ? void 0 : renderer(data, colIndex, scrollEl);
        default:
          return renderer;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTitle", function () {
      var _this$props2 = _this.props,
        colIndex = _this$props2.colIndex,
        data = _this$props2.data,
        scrollEl = _this$props2.scrollEl,
        title = _this$props2.title;
      switch ((0, _typeof2["default"])(title)) {
        case 'function':
          return title === null || title === void 0 ? void 0 : title(data, colIndex, scrollEl);
        default:
          return title;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props$onSortCha, _this$props5;
      var _this$props3 = _this.props,
        sortable = _this$props3.sortable,
        isClickSorting = _this$props3.isClickSorting,
        resizingColumn = _this$props3.resizingColumn;
      if (!sortable || !isClickSorting || resizingColumn) {
        return;
      }
      var _this$props4 = _this.props,
        sorting = _this$props4.sorting,
        defaultSortingType = _this$props4.defaultSortingType,
        sortingProp = _this$props4.sortingProp;
      var result = {};
      if (sorting && sorting.prop === sortingProp) {
        result.prop = sorting.prop;
        if (!sorting.type) {
          result.type = defaultSortingType;
        } else if (sorting.type === defaultSortingType) {
          result.type = -defaultSortingType;
        } else {
          result = null;
        }
      } else {
        result.prop = sortingProp;
        result.type = defaultSortingType;
      }
      (_this$props$onSortCha = (_this$props5 = _this.props).onSortChange) === null || _this$props$onSortCha === void 0 ? void 0 : _this$props$onSortCha.call(_this$props5, result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResize", function (width, e) {
      var _this$props$onColumns, _this$props6;
      var column = _this.props.column;
      (_this$props$onColumns = (_this$props6 = _this.props).onColumnsWidthChange) === null || _this$props$onColumns === void 0 ? void 0 : _this$props$onColumns.call(_this$props6, column, width, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeStart", function (width, e) {
      var _this$props$onColumnR, _this$props7;
      var column = _this.props.column;
      (_this$props$onColumnR = (_this$props7 = _this.props).onColumnResizeStart) === null || _this$props$onColumnR === void 0 ? void 0 : _this$props$onColumnR.call(_this$props7, column, width, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeStop", function (width, e) {
      var _this$props$onColumnR2, _this$props8;
      var column = _this.props.column;
      (_this$props$onColumnR2 = (_this$props8 = _this.props).onColumnResizeEnd) === null || _this$props$onColumnR2 === void 0 ? void 0 : _this$props$onColumnR2.call(_this$props8, column, width, e);
    });
    return _this;
  }

  /**
   * handle th content render
   * @returns {*}
   */
  (0, _createClass2["default"])(Th, [{
    key: "render",
    value: function render() {
      var _column$children, _classNames, _this$handleTitle;
      var _this$props9 = this.props,
        className = _this$props9.className,
        style = _this$props9.style,
        column = _this$props9.column,
        renderer = _this$props9.renderer,
        align = _this$props9.align,
        rowSpan = _this$props9.rowSpan,
        colSpan = _this$props9.colSpan,
        noWrap = _this$props9.noWrap,
        width = _this$props9.width,
        minColumnWidth = _this$props9.minColumnWidth,
        maxColumnWidth = _this$props9.maxColumnWidth,
        resizingColumn = _this$props9.resizingColumn,
        columnKeyField = _this$props9.columnKeyField,
        sortable = _this$props9.sortable,
        sortingProp = _this$props9.sortingProp,
        sorting = _this$props9.sorting,
        sortingAscIconCls = _this$props9.sortingAscIconCls,
        sortingDescIconCls = _this$props9.sortingDescIconCls,
        isClickSorting = _this$props9.isClickSorting;
      var isResizingActivated = _TableCalculation["default"].getColumnKey(column, columnKeyField) === _TableCalculation["default"].getColumnKey(resizingColumn, columnKeyField);
      var isSorting = sortable && sortingProp && sorting && sorting.prop && sorting.prop === sortingProp;
      return /*#__PURE__*/_react["default"].createElement(_ResizableTh["default"], {
        resizable: column.resizable && (!(column !== null && column !== void 0 && column.children) || (column === null || column === void 0 ? void 0 : (_column$children = column.children) === null || _column$children === void 0 ? void 0 : _column$children.length) < 1),
        activated: isResizingActivated,
        deactivated: resizingColumn && !isResizingActivated,
        width: width,
        minWidth: minColumnWidth,
        maxWidth: maxColumnWidth,
        onResize: this.handleResize,
        onResizeStart: this.handleResizeStart,
        onResizeStop: this.handleResizeStop
      }, /*#__PURE__*/_react["default"].createElement("th", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "align-".concat(align), align && align !== _HorizontalAlign["default"].LEFT), (0, _defineProperty2["default"])(_classNames, "sortable", sortable), (0, _defineProperty2["default"])(_classNames, "clickable", sortable && isClickSorting), (0, _defineProperty2["default"])(_classNames, "sorting", isSorting), (0, _defineProperty2["default"])(_classNames, "asc", isSorting && sorting.type > 0), (0, _defineProperty2["default"])(_classNames, "desc", isSorting && sorting.type < 0), (0, _defineProperty2["default"])(_classNames, 'no-wrap', sortable || noWrap), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        title: typeof renderer === 'string' ? renderer : null,
        rowSpan: rowSpan,
        colSpan: colSpan,
        onClick: this.handleClick
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "th-column"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "th-column-title",
        title: ((_this$handleTitle = this.handleTitle()) === null || _this$handleTitle === void 0 ? void 0 : _this$handleTitle.toString()) || null
      }, this.handleRender()), sortable ? /*#__PURE__*/_react["default"].createElement(_ThSortingIcon["default"], {
        sorting: sorting,
        sortingProp: sortingProp,
        sortingAscIconCls: sortingAscIconCls,
        sortingDescIconCls: sortingDescIconCls
      }) : null)));
    }
  }]);
  return Th;
}(_react.Component);
(0, _defineProperty2["default"])(Th, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Th, "SortingType", _SortingType["default"]);
Th.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  column: _propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    children: _propTypes["default"].any,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  }),
  columnKeyField: _propTypes["default"].string,
  renderer: _propTypes["default"].any,
  align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
  colIndex: _propTypes["default"].number,
  data: _propTypes["default"].array,
  title: _propTypes["default"].any,
  noWrap: _propTypes["default"].bool,
  rowSpan: _propTypes["default"].number,
  colSpan: _propTypes["default"].number,
  scrollEl: _propTypes["default"].object,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  sortable: _propTypes["default"].bool,
  sortingProp: _propTypes["default"].string,
  isClickSorting: _propTypes["default"].bool,
  /**
   * column resizable
   */
  width: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  maxColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  onSortChange: _propTypes["default"].func,
  onColumnsWidthChange: _propTypes["default"].func,
  onColumnResizeStart: _propTypes["default"].func,
  onColumnResizeEnd: _propTypes["default"].func
};
Th.defaultProps = {
  columnKeyField: 'key',
  colIndex: 0,
  noWrap: false,
  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  sortable: false,
  isClickSorting: true,
  /**
   * column resizable
   */
  minColumnWidth: 64,
  maxColumnWidth: Infinity
};
var _default = Th;
exports["default"] = _default;