"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TimeItems = _interopRequireDefault(require("../_TimeItems"));
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _DateCalculation = _interopRequireDefault(require("../_vendors/DateCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TimeList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TimeList, _Component);
  var _super = _createSuper(TimeList);
  function TimeList(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TimeList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHourChange", function (value) {
      var _this$props = _this.props,
        minValue = _this$props.minValue,
        maxValue = _this$props.maxValue,
        isRequired = _this$props.isRequired;
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;
      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }
      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }
      var flag = minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + _this.state.minute + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + _this.state.minute + ':' + _this.state.second).isAfter('2000-01-01 ' + maxValue),
        hour = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + _this.state.minute + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('HH') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH') : value,
        minute = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + _this.state.minute + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('mm') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm') : _this.state.minute,
        second = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + value + ':' + _this.state.minute + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('ss') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss') : _this.state.second;
      _this.setState({
        hour: hour,
        minute: minute,
        second: second,
        minutesData: minHour == value ? _DateCalculation["default"].rangeData(60, minMinute, 60, isRequired) : maxHour == value ? _DateCalculation["default"].rangeData(60, 0, maxMinute, isRequired) : maxHour == minHour && minHour == value ? _DateCalculation["default"].rangeData(60, minMinute, maxMinute, isRequired) : _DateCalculation["default"].rangeData(60, undefined, undefined, isRequired),
        secondsData: minHour == value && minMinute == _this.state.minute ? _DateCalculation["default"].rangeData(60, minSecond, 60, isRequired) : maxHour == value && maxMinute == _this.state.minute ? _DateCalculation["default"].rangeData(60, 0, maxSecond, isRequired) : maxHour == minHour && minHour == value && minMinute == maxMinute && minMinute == _this.state.minute ? _DateCalculation["default"].rangeData(60, minSecond, maxSecond, isRequired) : _DateCalculation["default"].rangeData(60, undefined, undefined, isRequired)
      }, function () {
        _this.props.onChange && _this.props.onChange({
          hour: hour,
          minute: minute,
          second: second
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMinuteChange", function (value) {
      var _this$props2 = _this.props,
        minValue = _this$props2.minValue,
        maxValue = _this$props2.maxValue,
        isRequired = _this$props2.isRequired;
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;
      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }
      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }
      var flag = minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + value + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + value + ':' + _this.state.second).isAfter('2000-01-01 ' + maxValue),
        hour = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + value + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('HH') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH') : _this.state.hour,
        minute = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + value + ':' + _this.state.second).isBefore('2000-01-01 ' + value) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('mm') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm') : value,
        second = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + value + ':' + _this.state.second).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('ss') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss') : _this.state.second;
      _this.setState({
        hour: hour,
        minute: minute,
        second: second,
        secondsData: minHour == _this.state.hour && minMinute == value ? _DateCalculation["default"].rangeData(60, minSecond, 60, isRequired) : maxHour == _this.state.hour && maxMinute == value ? _DateCalculation["default"].rangeData(60, 0, maxSecond, isRequired) : maxHour == minHour && minHour == _this.state.hour && minMinute == maxMinute && minMinute == value ? _DateCalculation["default"].rangeData(60, minSecond, maxSecond, isRequired) : _DateCalculation["default"].rangeData(60, undefined, undefined, isRequired)
      }, function () {
        _this.props.onChange && _this.props.onChange({
          hour: hour,
          minute: minute,
          second: second
        });
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSecondChange", function (value) {
      var _this$props3 = _this.props,
        minValue = _this$props3.minValue,
        maxValue = _this$props3.maxValue,
        flag = minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + _this.state.minute + ':' + value).isBefore('2000-01-01 ' + minValue) || maxValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + _this.state.minute + ':' + value).isAfter('2000-01-01 ' + maxValue),
        hour = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + _this.state.minute + ':' + value).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('HH') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('HH') : _this.state.hour,
        minute = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + _this.state.minute + ':' + value).isBefore('2000-01-01 ' + value) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('mm') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('mm') : _this.state.minute,
        second = flag ? minValue && (0, _moment["default"])('2000-01-01 ' + _this.state.hour + ':' + _this.state.minute + ':' + value).isBefore('2000-01-01 ' + minValue) ? (0, _moment["default"])('2000-01-01 ' + minValue).format('ss') : (0, _moment["default"])('2000-01-01 ' + maxValue).format('ss') : value;
      _this.setState({
        hour: hour,
        minute: minute,
        second: second
      }, function () {
        _this.props.onChange && _this.props.onChange({
          hour: hour,
          minute: minute,
          second: second
        });
      });
    });
    _this.state = {
      hour: props.hour,
      minute: props.minute,
      second: props.second,
      hoursData: [],
      minutesData: [],
      secondsData: []
    };
    return _this;
  }

  /* eslint-disable complexity */
  (0, _createClass2["default"])(TimeList, [{
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
        className = _this$props4.className,
        popupVisible = _this$props4.popupVisible,
        dateFormat = _this$props4.dateFormat,
        _this$state = this.state,
        hour = _this$state.hour,
        minute = _this$state.minute,
        second = _this$state.second,
        hoursData = _this$state.hoursData,
        minutesData = _this$state.minutesData,
        secondsData = _this$state.secondsData,
        itemsStyle = {
          width: 100 / dateFormat.split(':').length + '%'
        };
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('calendar', (0, _defineProperty2["default"])({}, className, className))
      }, /*#__PURE__*/_react["default"].createElement(_TimeItems["default"], {
        className: "hours",
        style: itemsStyle,
        data: hoursData,
        value: hour,
        popupVisible: popupVisible,
        onChange: this.handleHourChange
      }), dateFormat.split(':').length > 1 ? /*#__PURE__*/_react["default"].createElement(_TimeItems["default"], {
        className: "minutes",
        style: itemsStyle,
        data: minutesData,
        value: minute,
        popupVisible: popupVisible,
        onChange: this.handleMinuteChange
      }) : null, dateFormat.split(':').length > 2 ? /*#__PURE__*/_react["default"].createElement(_TimeItems["default"], {
        className: "seconds",
        style: itemsStyle,
        data: secondsData,
        value: second,
        popupVisible: popupVisible,
        onChange: this.handleSecondChange
      }) : null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var minValue = _ComponentUtil["default"].getDerivedState(props, state, 'minValue'),
        maxValue = _ComponentUtil["default"].getDerivedState(props, state, 'maxValue'),
        isRequired = _ComponentUtil["default"].getDerivedState(props, state, 'isRequired');
      var minHour, minMinute, minSecond, maxHour, maxMinute, maxSecond;
      if (minValue) {
        minHour = minValue.split(':')[0];
        minMinute = minValue.split(':')[1];
        minSecond = minValue.split(':')[2];
      }
      if (maxValue) {
        maxHour = maxValue.split(':')[0];
        maxMinute = maxValue.split(':')[1];
        maxSecond = maxValue.split(':')[2];
      }
      return {
        prevProps: props,
        hoursData: _DateCalculation["default"].rangeData(24, minHour, maxHour, isRequired),
        minutesData: minHour == state.hour ? _DateCalculation["default"].rangeData(60, minMinute, 60, isRequired) : maxHour == state.hour ? _DateCalculation["default"].rangeData(60, 0, maxMinute, isRequired) : maxHour == minHour && minHour == state.hour ? _DateCalculation["default"].rangeData(60, minMinute, maxMinute, isRequired) : _DateCalculation["default"].rangeData(60, undefined, undefined, isRequired),
        secondsData: minHour == state.hour && minMinute == state.minute ? _DateCalculation["default"].rangeData(60, minSecond, 60, isRequired) : maxHour == state.hour && maxMinute == state.minute ? _DateCalculation["default"].rangeData(60, 0, maxSecond, isRequired) : maxHour == minHour && minHour == state.hour && minMinute == maxMinute && minMinute == state.minute ? _DateCalculation["default"].rangeData(60, minSecond, maxSecond, isRequired) : _DateCalculation["default"].rangeData(60, undefined, undefined, isRequired),
        hour: props.hour,
        minute: props.minute,
        second: props.second,
        minValue: props.minValue,
        maxValue: props.maxValue,
        isRequired: isRequired
      };
    }
  }]);
  return TimeList;
}(_react.Component);
TimeList.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  popupVisible: _propTypes["default"].bool,
  hour: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  minute: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  second: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  isRequired: _propTypes["default"].bool,
  maxValue: _propTypes["default"].string,
  minValue: _propTypes["default"].string,
  dateFormat: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
var _default = TimeList;
exports["default"] = _default;