"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _DateUtil = _interopRequireDefault(require("../_vendors/DateUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var YearPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(YearPicker, _Component);
  var _super = _createSuper(YearPicker);
  function YearPicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, YearPicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "selectDate", function (selectYear) {
      var onChange = _this.props.onChange;
      _this.setState({
        currentYear: selectYear,
        selectYear: selectYear
      }, function () {
        onChange && onChange(selectYear);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "previousYear", function () {
      var selectYear = _this.state.selectYear;
      _this.setState({
        YearArr: _DateUtil["default"].getYearArr(+selectYear - 10),
        selectYear: +selectYear - 10
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "nextYear", function () {
      var selectYear = _this.state.selectYear;
      _this.setState({
        YearArr: _DateUtil["default"].getYearArr(+selectYear + 10),
        selectYear: +selectYear + 10
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "yearsRender", function () {
      var _this$props = _this.props,
        maxValue = _this$props.maxValue,
        minValue = _this$props.minValue,
        _this$state = _this.state,
        YearArr = _this$state.YearArr,
        selectYear = _this$state.selectYear,
        _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
        selectDate = _assertThisInitialize.selectDate;
      var previousYearsArray = [],
        currentYearsArray = [],
        nextYearsArray = [],
        totalYearsArray = [],
        yearsList = [];
      previousYearsArray.push( /*#__PURE__*/_react["default"].createElement("li", {
        className: "item-gray",
        key: Number(YearArr[0]) - 1
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "date-text"
      }, Number(YearArr[0]) - 1)));
      var _loop = function _loop(i) {
        var liClassName = (0, _classnames["default"])({
          'active': +selectYear === +YearArr[i],
          'item-gray': maxValue && (0, _moment["default"])(maxValue).format('YYYY') < Number(YearArr[i]) || minValue && (0, _moment["default"])(minValue).format('YYYY') > Number(YearArr[i]),
          'current-years': !(maxValue && (0, _moment["default"])(maxValue).format('YYYY') < Number(YearArr[i])) || minValue && (0, _moment["default"])(minValue).format('YYYY') > Number(YearArr[i])
        });
        currentYearsArray.push( /*#__PURE__*/_react["default"].createElement("li", {
          className: liClassName,
          key: 'current' + i,
          onClick: function onClick() {
            liClassName.indexOf('item-gray') === -1 && selectDate(YearArr[i]);
          }
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "date-text"
        }, YearArr[i], liClassName.indexOf('item-gray') === -1 ? /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null) : null)));
      };
      for (var i = 0; i < YearArr.length; i++) {
        _loop(i);
      }
      nextYearsArray.push( /*#__PURE__*/_react["default"].createElement("li", {
        className: "item-gray",
        key: Number(YearArr[YearArr.length - 1]) + 1
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "date-text"
      }, Number(YearArr[YearArr.length - 1]) + 1)));
      totalYearsArray = previousYearsArray.concat(currentYearsArray, nextYearsArray);
      if (totalYearsArray.length > 0) {
        for (var _i = 0; _i < _this.defaultTable.rowNumber; _i++) {
          var rowlist = [],
            startIndex = _i * _this.defaultTable.colNumber,
            endIndex = (_i + 1) * _this.defaultTable.colNumber;
          for (var j = startIndex; j < endIndex; j++) {
            rowlist.push(totalYearsArray[j]);
          }
          yearsList.push(rowlist);
        }
      }
      return yearsList;
    });
    _this.defaultTable = {
      rowNumber: 4,
      colNumber: 3
    };
    _this.state = {
      YearArr: _DateUtil["default"].getYearArr(props.year),
      selectYear: props.year,
      currentYear: (0, _moment["default"])(props.value).format('YYYY'),
      selectMonth: props.month,
      selectDay: props.day,
      maxValue: props.maxValue,
      minValue: props.minValue
    };
    return _this;
  }
  (0, _createClass2["default"])(YearPicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
        value = _this$props2.value,
        year = _this$props2.year;
      if (value && year) {
        this.setState({
          YearArr: _DateUtil["default"].getYearArr(year),
          selectYear: year,
          currentYear: (0, _moment["default"])(value).format('YYYY'),
          currentMonth: (0, _moment["default"])(value).format('MM')
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        maxValue = _this$props3.maxValue,
        minValue = _this$props3.minValue,
        previousYearIconCls = _this$props3.previousYearIconCls,
        nextYearIconCls = _this$props3.nextYearIconCls,
        _this$state2 = this.state,
        YearArr = _this$state2.YearArr,
        selectYear = _this$state2.selectYear,
        previousYear = this.previousYear,
        nextYear = this.nextYear,
        yearsRenderArray = this.yearsRender(),
        selectedYear = selectYear.toString(),
        yearRangeEnd = selectedYear.substr(0, selectedYear.length - 1) + '9',
        yearRangeStart = selectedYear.substr(0, selectedYear.length - 1) + '1',
        leftNextYear = maxValue && +(0, _moment["default"])(maxValue).format('YYYY') <= +yearRangeEnd,
        rightPreYear = minValue && +(0, _moment["default"])(minValue).format('YYYY') >= +yearRangeStart;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: 'calendar'
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-header"
      }, rightPreYear ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('previous-year', (0, _defineProperty2["default"])({}, previousYearIconCls, previousYearIconCls)),
        onClick: previousYear
      }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null)), /*#__PURE__*/_react["default"].createElement("span", {
        className: "date-text"
      }, YearArr[0], "-", YearArr[YearArr.length - 1]), leftNextYear ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: (0, _classnames["default"])('next-year', (0, _defineProperty2["default"])({}, nextYearIconCls, nextYearIconCls)),
        onClick: nextYear
      }, /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], null))), /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-body calendar-year-body"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "c-body-content"
      }, yearsRenderArray && yearsRenderArray.map(function (item, key) {
        return /*#__PURE__*/_react["default"].createElement("ul", {
          key: 'ul' + key,
          className: "content-row year"
        }, item);
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        selectYear = _ComponentUtil["default"].getDerivedState(props, state, 'year', 'selectYear');
      return {
        prevProps: props,
        value: value,
        selectYear: selectYear,
        YearArr: _DateUtil["default"].getYearArr(selectYear),
        currentYear: (0, _moment["default"])(value).format('YYYY'),
        currentMonth: (0, _moment["default"])(value).format('MM')
      };
    }
  }]);
  return YearPicker;
}(_react.Component);
YearPicker.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  value: _propTypes["default"].any,
  maxValue: _propTypes["default"].any,
  minValue: _propTypes["default"].any,
  previousYearIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  year: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  month: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  day: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  onChange: _propTypes["default"].func
};
var _default = YearPicker;
exports["default"] = _default;